'''
Created on Feb 6, 2018

@author: Steven Fletcher - INRIA - Institut Pasteur - InBio
'''
import os
import json
import glob
import re
import logging
import MicroMator.DataManagement.protocol_structure as ps
from MicroMator.FileManagement import logger

MODULE = 'FileManagement'

###FOR micromanager 2.0 beta & gamma
class AcquisitionDataExtractormm2():
    '''this class regroups all the methods that are used to extract the Acquisition json
    '''
    def __init__(self, folder_manager_obj, options):
        '''Args:
            folder_manager_obj(object): the instance of the Filer object
            options(dict): the dict of options read from the .json file
        '''
        self.options = options
        self.folder_manager_obj = folder_manager_obj
        logging.basicConfig(filename=self.folder_manager_obj.micromator_log_path, level=logging.DEBUG, format='%(asctime)s : %(message)s', datefmt='%Y/%m/%d %I:%M:%S %p')
        self.acqNumframes = self.posfile = self.acqInterval = self.acquorder = None
        self.slices = []
        self.relativeZSlice = False
        self.channel_list = []
        self.channelGroup = None
        self.acqfile = None
        while True:
            try:
                self.find_acq_file()
                break
            except FileNotFoundError:
                logger('No .acq file found, please make sure the .acq file is present', print_=False, module=MODULE)
                _ = input('No .acq file found, please make sure the .acq file is present then and press Enter when ready...')
        self.protocol_reader()

    def find_acq_file(self):
        '''gets the acquisiton file generated by saving the multidimensional acquisition in Micromanager
        MUST be .acq and in protocols folder.
        '''
        acqfilecount = 0
        for file_ in os.listdir(self.folder_manager_obj.protocols_path):
            if file_.endswith('.acq'):
                acqfilecount += 1
                self.acqfile = os.path.join(self.folder_manager_obj.protocols_path, file_)
                if acqfilecount > 1:
                    logger('more than 1 acquisition file present...selected the first one in the list', 'warning')
        if not self.acqfile:
            raise FileNotFoundError

    def protocol_reader(self):
        '''this function reads the acquition file and fills the Protocol object
        '''
        with open(self.acqfile) as acqfile:
            acqdata = json.load(acqfile)
            acqorder = acqdata['timeFirst']
            if acqorder:
                self.acquorder = 'PTC'
            else:
                self.acquorder = 'TPC'
            self.acqNumframes = acqdata['numFrames']
            self.acqInterval = acqdata['intervalMs']/1000.
            if acqdata['useAutofocus']:
                self.skipAutofocusCount = acqdata['skipAutofocusCount']
            if not acqdata.get('channels'):
                raise NameError('No channels where found in the .aqu file!!!')
            for index in range(len(acqdata['channels'])):
                channel = acqdata['channels'][index]
                name = channel['config']
                exposure = channel['exposure']
                if name != self.options['MICROMANAGER_PARAMETERS']["brightfield"]:
                    fluo = True
                else:
                    fluo = False
                skipFactorFrame = 0
                if channel['skipFactorFrame'] != 0:
                    skipFactorFrame = channel['skipFactorFrame']
                self.channel_list.append(ps.Channel(index, name, exposure, fluo, skipFactorFrame))
            self.channel_list = rename_channels_w_same_name(self.channel_list)
            self.slices = acqdata['slices']
            logger('Zslices: {}'.format(self.slices), module=MODULE)
            self.channelGroup = acqdata["channelGroup"]
            logger('channelGroup {}'.format(self.channelGroup), module=MODULE)
            self.relativeZSlice = acqdata['relativeZSlice']
            logger('relativeZSlice: {}'.format(self.relativeZSlice), module=MODULE)

    def fill_protocol_structure(self, timestamp, positions_list, dmd, track):
        '''Args:
            timestamp(int): the current time
            positions_list(Positions object): the list of positions used during the acquisition
            dmd(bool): True if dmd is enabled
            track(bool): true if stracking is enabled
        '''
        return ps.Protocol(timestamp, self.acquorder, self.acqNumframes, self.acqInterval, self.channel_list, positions_list, dmd, track)

def rename_channels_w_same_name(list_channels):
    '''goes through channels and adds extension to channel name
    '''
    names = []
    count = 0
    for channel in list_channels:
        if channel.name in names:
            channel.path += '{}'.format(count)
            count += 1
        names.append(channel.name)
    return list_channels

###FOR micromanager 1.4.22 or 1.4.23
class AcquisitionDataExtractormm14():
    '''this class regroups all the methods that are used to extract the Acquisition info the experiment (.xml and .pos)
    '''
    def __init__(self, folder_manager_obj, options):
        '''Args:
        folder_manager_obj(object): the instance of the folder manager object
        options(dict): the dict of options read from the .json file
        '''
        self.options = options
        acquprotocol = os.path.join(folder_manager_obj.protocols_path, '*.xml')
        logging.basicConfig(filename=folder_manager_obj.micromator_log_path, level=logging.DEBUG, format='%(asctime)s : %(message)s', datefmt='%Y/%m/%d %I:%M:%S %p')
        self.inputfile = glob.glob(acquprotocol)[0]#gets name of .xml file (acquisition protocol)
        if len(glob.glob(acquprotocol)) == 0:
            logger('missing the acquisition protocol', 'error', module=MODULE)
        if len(glob.glob(acquprotocol)) != 1:
            logger('more than 1 acquisition protocol present...selected the first one in the list', 'warning', module=MODULE)
        self.inputdict = {}
        self.reg = re.compile(r'(?<=\")(.*)(?=\")') #extracts the data from the useless symbols (\"= etc.. (see regex101.com with this string as example  : 'value="true"/>'
        self.regchname = re.compile('acqChannelName[0-9]*')
        self.regchexp = re.compile('acqChannelExp[0-9]*')
        self.channel_list = []
        self.acqNumframes = self.posfile = self.acqInterval = self.acquorder = self.number_channels = None
        self.get_input_xml()
        self.extract_data_xml()

    def get_input_xml(self):
        '''method gets and reads the saved .xml file that contains the acquisition settings and saves it in self.inputdict
        '''
        with open(self.inputfile, 'r') as f:
            lines = f.readlines()
            for line in lines:
                if '<entry key' in line:
                    sline = line.split()
                    if len(sline) == 3:
                        skey = re.search(self.reg, sline[1])
                        svalue = re.search(self.reg, sline[2])
                    if skey and svalue:
                        key = skey.group(1)
                        value = svalue.group(1)
                    self.inputdict[key] = value

    def extract_data_xml(self):
        '''method to extract data from dict of the .xml file
        '''
        if self.inputdict['acqOrderMode'] == '0':
            self.acquorder = 'TPC'
        elif self.inputdict['acqOrderMode'] == '2':
            self.acquorder = 'PTC'
        elif self.inputdict['acqOrderMode'] == '4':
            self.acquorder = 'DEBUG'
            logger('Debug Acquisition', module=MODULE)
        else:
            raise NameError('Unknown Acquisition mode (must be either TPC or PTC)')
        self.acqNumframes = int(self.inputdict['acqNumframes'])
        self.acqInterval = float(self.inputdict['acqInterval'])/1000.
        self.number_channels = int(self.inputdict['acqNumchannels'])
        if int(self.number_channels) != 0:
            for index in range(self.number_channels):
                self.channel_list.append(ps.Channel(index, None, None))
            for key, value in list(self.inputdict.items()):
                if 'acqChannelName' in key:
                    index = int(key[-1])
                    self.channel_list[index].name = value
                    if value != self.options['MICROMANAGER_PARAMETERS']["brightfield"]:
                        self.channel_list[index].fluo = True
                elif 'acqChannelExp' in key:
                    index = int(key[-1])
                    self.channel_list[index].exposure = float(value)
        else:
            self.channel_list.append(ps.Channel(0, self.options['MICROMANAGER_PARAMETERS']["brightfield"], 30, False))
        self.channel_list = rename_channels_w_same_name(self.channel_list)

    def extract_pos_file(self, folder_manager_obj):
        '''gets the positions file generated by saving the postions in Micromanager
        MUST be .pos and in protocols folder.
        '''
        posfilecount = 0
        for file_ in os.listdir(folder_manager_obj.protocols_path):
            if file_.endswith('.pos'):
                posfilecount +=1
                self.posfile = os.path.join(folder_manager_obj.protocols_path, file_)
                if posfilecount > 1:
                    logger('more than 1 position list present...selected the first one in the list', 'warning', module=MODULE)
        if not self.posfile:
            logger('No .pos file found, current position will be taken. To generate the .pos file use Micromanager', 'error', module=MODULE)

    def fill_protocol_structure(self, timestamp, positions_list, dmd, track):
        '''Args:
            timestamp(int): the current time
            positions_list(Positions object): the list of positions used during the acquisition
            dmd(bool): True if dmd is enabled
            track(bool): true if stracking is enabled
        '''
        #logger(self.channel_list)
        protocol = ps.Protocol(timestamp, self.acquorder, self.acqNumframes, self.acqInterval, self.channel_list, positions_list, dmd, track)
        return protocol
